<?php
if (!defined('ABSPATH')) {
    exit;
}

function api_post_grid_get_posts(WP_REST_Request $request)
{
    $category = $request->get_param('category');
    $per_page = $request->get_param('per_page');
    $page = $request->get_param('page');
    $order = $request->get_param('order');
    $orderby = $request->get_param('orderby');

    // Query Arguments
    $args = [
        'post_type' => 'post',
        'posts_per_page' => $per_page,
        'paged' => $page,
        'order' => $order,
        'orderby' => $orderby,
        'category_name' => $category,
        'post_status' => 'publish',
    ];

    $query = new WP_Query($args);

    $posts = [];
    if ($query->have_posts()) {
        while ($query->have_posts()) {
            $query->the_post();
            $featured_image = get_the_post_thumbnail_url(get_the_ID(), 'medium');

            $posts[] = [
                'id' => get_the_ID(),
                'title' => get_the_title(),
                'link' => get_permalink(),
                'image' => $featured_image ? $featured_image : 'default-image.jpg',
            ];
        }
    }

    wp_reset_postdata();

    // Menambahkan total_posts ke dalam response
    $response = [
        'total_posts' => $query->found_posts,
        'posts' => $posts,
    ];

    return rest_ensure_response($response);
}
